# Intrepyd
Intre**py**d is a **python** module that provides a simulator and a model checker in form of
a rich API, to allow the rapid prototyping of **formal methods** algorithms
for the rigorous analysis of circuits, specifications, models.

Intrepid may also be run as a containerized web service, which can be used interactively
via a rich REST API.

# Index
1  [Presentation](#presentation)
1. [Installation](#installation)
    1. [Officially Supported OSes](#officially-supported-oses)
    1. [Prerequisites](#prerequisites)
1. [Quick Start](#quick-start)
    1. [Constructing Models](#constructing-models)
    1. [Simulating Models](#simulating-models)
    1. [Model Checking](#model-checking)
    1. [Benchmarking](#benchmarking)
    1. [Model Checking in the Cloud](#model-checking-in-the-cloud)
    1. [API documentation](#api-documentation)
1. [Resources](#resources)
    1. [Formal Methods Little Corner](#formal-methods-little-corner)
    1. [Bug reporting](#bug-reporting)
    1. [Feedback](#feedback)


# Presentation

A presentation video may be found [here](https://youtu.be/n-0Y_iJqkqY).

# Installation
Intrepyd is available from PYPI [here][2]. It can be installed simply with
```
pip3 install intrepyd
```
issued from a terminal.

If you wish to use intrepyd in an isolated environment you may use docker as
follows
```
docker run -it python:3.9 /bin/bash
pip3 install intrepyd
```

## Officially Supported OSes
- Windows 10
- Linux
- OSX

## Prerequisites
- python 3.9 (exactly this version)
- (Windows only) [Visual C++ Redistributable for Visual Studio][1]

# Quick start

## Constructing Models
TODO

## Simulating Models
TODO

## Model Checking
TODO

## Benchmarking
TODO

## Model Checking in the Cloud
TODO

# Resources

## Api Documentation

The documentation for the python API can be found under [here](https://github.com/formalmethods/intrepid/tree/master/docs/intrepyd)

The documentation for the REST API can be found [here](https://www.postman.com/robertobruttomesso/workspace/intrepid-model-checker-rest-api)

## Docker Hub

The docker hub page is available [here](https://hub.docker.com/r/robertobruttomesso/intrepid)

## Formal Methods Little Corner
A collection of experiences using Intrepyd can be found [here](https://formalmethods.github.io).

## Bug reporting
Please report any bug you should experience [here](https://github.com/formalmethods/intrepid/issues).

## Feedback
If you wish to drop a feedback you may write to
`roberto.bruttomesso@gmail.com`.

[1]: https://aka.ms/vs/16/release/vc_redist.x64.exe
[2]: https://pypi.python.org/pypi/intrepyd "Intrepyd on PYPI"
